--- /dev/null	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/xsave/bad_xregs.c	Wed Apr 12 20:33:28 2023
@@ -0,0 +1,723 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This attempts to do a series of writes to the /proc control file that have
+ * invalid data for the xregs state. The way that this works is that we create a
+ * thread that will be detached and just sleeps whenever it wakes up. We direct
+ * this thread to stop with a directed PCSTOP via libproc.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <libproc.h>
+#include <thread.h>
+#include <errno.h>
+#include <string.h>
+#include <sys/sysmacros.h>
+#include <sys/debug.h>
+#include <sys/x86_archext.h>
+
+#include "xsave_util.h"
+
+static prxregset_t *bad_xregs_pxr;
+static size_t bad_xregs_size;
+
+typedef struct bad_xregs_test {
+	const char *bxt_desc;
+	int bxt_errno;
+	uint32_t bxt_min;
+	void (*bxt_setup)(void **, size_t *);
+} bad_xregs_test_t;
+
+static void
+bad_xregs_no_data(void **bufp, size_t *sizep)
+{
+	*bufp = NULL;
+	*sizep = 0;
+}
+
+static void
+bad_xregs_null_buf(void **bufp, size_t *sizep)
+{
+	*bufp = NULL;
+	*sizep = sizeof (prxregset_hdr_t);
+}
+
+static void
+bad_xregs_short_hdr(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = calloc(1, sizeof (prxregset_hdr_t));
+	if (hdr == NULL) {
+		err(EXIT_FAILURE, "failed to allocate header");
+	}
+
+	hdr->pr_type = PR_TYPE_XSAVE;
+	hdr->pr_size = sizeof (prxregset_hdr_t);
+
+	*bufp = hdr;
+	*sizep = sizeof (prxregset_hdr_t) - 4;
+}
+
+static void
+bad_xregs_hdr_too_large(void **bufp, size_t *sizep)
+{
+	uint32_t large = 32 * 1024 * 1024; /* 4 MiB */
+	prxregset_hdr_t *hdr = malloc(32 * 1024 * 1024);
+	if (hdr == NULL) {
+		err(EXIT_FAILURE, "failed to allocate regset");
+	}
+
+	(void) memcpy(hdr, bad_xregs_pxr, bad_xregs_size);
+	hdr->pr_size = large;
+
+	*bufp = hdr;
+	*sizep = large;
+}
+
+static prxregset_hdr_t *
+bad_xregs_std_init(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = malloc(bad_xregs_size);
+	if (hdr == NULL) {
+		err(EXIT_FAILURE, "failed to allocate regset");
+	}
+
+	(void) memcpy(hdr, bad_xregs_pxr, bad_xregs_size);
+
+	*bufp = hdr;
+	*sizep = bad_xregs_size;
+	return (hdr);
+}
+
+static void
+bad_xregs_missing_data(void **bufp, size_t *sizep)
+{
+	(void) bad_xregs_std_init(bufp, sizep);
+	*sizep /= 2;
+}
+
+static void
+bad_xregs_hdr_bad_type(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_type = PR_TYPE_XSAVE + 167;
+}
+
+static void
+bad_xregs_hdr_bad_flags(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_flags = 0x123;
+}
+
+static void
+bad_xregs_hdr_bad_pad0(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_pad[0] = 0x456;
+}
+
+static void
+bad_xregs_hdr_bad_pad1(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_pad[1] = 0x789;
+}
+
+static void
+bad_xregs_hdr_bad_pad2(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_pad[2] = 0xabc;
+}
+
+static void
+bad_xregs_hdr_bad_pad3(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_pad[3] = 0xdef;
+}
+
+static void
+bad_xregs_hdr_no_info(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_ninfo = 0;
+}
+
+static void
+bad_xregs_hdr_no_info_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	uint32_t len = sizeof (prxregset_hdr_t) + sizeof (prxregset_info_t) *
+	    hdr->pr_ninfo;
+	hdr->pr_size = len - 4;
+}
+
+static void
+bad_xregs_info_type(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_info[0].pri_type = 0xbaddcafe;
+}
+
+static void
+bad_xregs_info_flags(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	VERIFY3U(hdr->pr_ninfo, >=, 2);
+	hdr->pr_info[1].pri_flags = 0x120b0;
+}
+
+static prxregset_info_t *
+bad_xregs_find_info(prxregset_hdr_t *hdr, uint32_t type)
+{
+	for (uint32_t i = 0; i < hdr->pr_ninfo; i++) {
+		if (hdr->pr_info[i].pri_type == type) {
+			return (&hdr->pr_info[i]);
+		}
+	}
+
+	return (NULL);
+}
+
+static void
+bad_xregs_info_xcr_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XCR);
+	VERIFY3P(info, !=, NULL);
+	info->pri_size--;
+}
+
+static void
+bad_xregs_info_xcr_off(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XCR);
+	VERIFY3P(info, !=, NULL);
+	info->pri_offset++;
+}
+
+static void
+bad_xregs_info_xsave_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	info->pri_size--;
+}
+
+static void
+bad_xregs_info_xsave_off(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	info->pri_offset--;
+}
+
+static void
+bad_xregs_info_ymm_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_YMM);
+	VERIFY3P(info, !=, NULL);
+	info->pri_size--;
+}
+
+static void
+bad_xregs_info_ymm_off(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_YMM);
+	VERIFY3P(info, !=, NULL);
+	info->pri_offset--;
+}
+
+static void
+bad_xregs_info_opmask_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_OPMASK);
+	VERIFY3P(info, !=, NULL);
+	info->pri_size--;
+}
+
+static void
+bad_xregs_info_opmask_off(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_OPMASK);
+	VERIFY3P(info, !=, NULL);
+	info->pri_offset--;
+}
+
+static void
+bad_xregs_info_zmm_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_ZMM);
+	VERIFY3P(info, !=, NULL);
+	info->pri_size--;
+}
+
+static void
+bad_xregs_info_zmm_off(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_ZMM);
+	VERIFY3P(info, !=, NULL);
+	info->pri_offset--;
+}
+
+static void
+bad_xregs_info_hi_zmm_len(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_HI_ZMM);
+	VERIFY3P(info, !=, NULL);
+	info->pri_size--;
+}
+
+static void
+bad_xregs_info_hi_zmm_off(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_HI_ZMM);
+	VERIFY3P(info, !=, NULL);
+	info->pri_offset--;
+}
+
+static void
+bad_xregs_info_exceeds_len0(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_info[0].pri_offset = hdr->pr_size + 4;
+}
+
+static void
+bad_xregs_info_exceeds_len1(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_info[0].pri_offset = hdr->pr_size - hdr->pr_info[0].pri_size +
+	    8;
+}
+
+static void
+bad_xregs_info_overlaps(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	hdr->pr_info[0].pri_offset = sizeof (prxregset_hdr_t) + 8;
+}
+
+static void
+bad_xregs_trim_entry(prxregset_hdr_t *hdr, uint32_t type)
+{
+	boolean_t found = B_FALSE;
+	/*
+	 * Walk the info structures and clip out everything after the xsave
+	 * entry. This almost suggets it'd be nice to have a nop type that was
+	 * ignored.
+	 */
+	for (uint32_t i = 0; i < hdr->pr_ninfo; i++) {
+		if (hdr->pr_info[i].pri_type == type) {
+			found = B_TRUE;
+		}
+
+		if (found && i + 1 != hdr->pr_ninfo) {
+			hdr->pr_info[i] = hdr->pr_info[i + 1];
+		}
+	}
+
+	VERIFY3U(found, ==, B_TRUE);
+	hdr->pr_ninfo--;
+}
+
+static void
+bad_xregs_no_xsave(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	bad_xregs_trim_entry(hdr, PRX_INFO_XSAVE);
+}
+
+static void
+bad_xregs_missing_xstate(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	bad_xregs_trim_entry(hdr, PRX_INFO_YMM);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+
+	xsave->prx_xsh_xstate_bv |= XFEATURE_AVX;
+}
+
+static void
+bad_xregs_xcr_bad_xcr0(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XCR);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xcr_t *xcr = (void *)((uintptr_t)*bufp + info->pri_offset);
+	xcr->prx_xcr_xcr0 = ~xcr->prx_xcr_xcr0;
+}
+
+static void
+bad_xregs_xcr_bad_xfd(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XCR);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xcr_t *xcr = (void *)((uintptr_t)*bufp + info->pri_offset);
+	xcr->prx_xcr_xfd = ~xcr->prx_xcr_xfd;
+}
+
+static void
+bad_xregs_xcr_bad_pad0(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XCR);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xcr_t *xcr = (void *)((uintptr_t)*bufp + info->pri_offset);
+	xcr->prx_xcr_pad[0] = 0xdeadbeef;
+}
+
+static void
+bad_xregs_xcr_bad_pad1(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XCR);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xcr_t *xcr = (void *)((uintptr_t)*bufp + info->pri_offset);
+	xcr->prx_xcr_pad[1] = 0xf00b412;
+}
+
+static void
+bad_xregs_xsave_bad_xbv(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	/*
+	 * bit 8 is a supervisor state that we don't currently have defined in
+	 * <sys/x86_archext.h> and should always end up being something we don't
+	 * see in userland.
+	 */
+	xsave->prx_xsh_xstate_bv |= (1 << 8);
+}
+
+static void
+bad_xregs_xsave_bad_xcomp(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	/*
+	 * bit 63 is used to say that this is valid. Given that we don't support
+	 * it, we just set that bit as the most realistic example of what could
+	 * happen.
+	 */
+	xsave->prx_xsh_xcomp_bv |= (1ULL << 63);
+}
+
+static void
+bad_xregs_xsave_bad_rsvd0(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	xsave->prx_xsh_reserved[0] = 0xff10;
+}
+
+static void
+bad_xregs_xsave_bad_rsvd1(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	xsave->prx_xsh_reserved[1] = 0x87654321;
+}
+
+static void
+bad_xregs_xsave_bad_rsvd2(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	xsave->prx_xsh_reserved[2] = 0x167169;
+}
+
+static void
+bad_xregs_xsave_bad_rsvd3(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	xsave->prx_xsh_reserved[3] = 0xff7;
+}
+
+static void
+bad_xregs_xsave_bad_rsvd4(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	xsave->prx_xsh_reserved[4] = 0x00f00;
+}
+
+static void
+bad_xregs_xsave_bad_rsvd5(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_XSAVE);
+	VERIFY3P(info, !=, NULL);
+	prxregset_xsave_t *xsave = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	xsave->prx_xsh_reserved[5] = 0x2374013;
+}
+
+/*
+ * The following tests are all 32-bit specific.
+ */
+#ifdef __i386
+static void
+bad_xregs_ymm_ilp32(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_YMM);
+	VERIFY3P(info, !=, NULL);
+	prxregset_ymm_t *ymm = (void *)((uintptr_t)*bufp + info->pri_offset);
+	ymm->prx_rsvd[4]._l[3] = 0x12345;
+}
+
+static void
+bad_xregs_zmm_ilp32(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_ZMM);
+	VERIFY3P(info, !=, NULL);
+	prxregset_zmm_t *zmm = (void *)((uintptr_t)*bufp + info->pri_offset);
+	zmm->prx_rsvd[2]._l[5] = 0x23456;
+}
+
+static void
+bad_xregs_hi_zmm_ilp32(void **bufp, size_t *sizep)
+{
+	prxregset_hdr_t *hdr = bad_xregs_std_init(bufp, sizep);
+	prxregset_info_t *info = bad_xregs_find_info(hdr, PRX_INFO_HI_ZMM);
+	VERIFY3P(info, !=, NULL);
+	prxregset_hi_zmm_t *hi_zmm = (void *)((uintptr_t)*bufp +
+	    info->pri_offset);
+	hi_zmm->prx_rsvd[1]._l[9] = 0x34567;
+}
+#endif	/* __i386 */
+
+static const bad_xregs_test_t bad_tests[] = {
+	{ "no data (NULL buffer)", EINVAL, XSU_YMM, bad_xregs_no_data },
+	{ "NULL buffer, non-zero count", EFAULT, XSU_YMM, bad_xregs_null_buf },
+	{ "incomplete prxregset_hdr_t", EINVAL, XSU_YMM, bad_xregs_short_hdr },
+	{ "prxregset_hdr_t has wrong type", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_bad_type },
+	{ "prxregset_hdr_t size is too large", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_too_large },
+	{ "prxregset_hdr_t size bigger than /proc write", EINVAL, XSU_YMM,
+	    bad_xregs_missing_data },
+	{ "prxregset_hdr_t invalid flags", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_bad_flags },
+	{ "prxregset_hdr_t invalid pad[0]", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_bad_pad0 },
+	{ "prxregset_hdr_t invalid pad[1]", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_bad_pad1 },
+	{ "prxregset_hdr_t invalid pad[2]", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_bad_pad2 },
+	{ "prxregset_hdr_t invalid pad[3]", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_bad_pad3 },
+	{ "prxregset_hdr_t no info structures", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_no_info },
+	{ "prxregset_hdr_t len doesn't cover info structures", EINVAL, XSU_YMM,
+	    bad_xregs_hdr_no_info_len },
+	{ "prxregset_info_t has bad flags", EINVAL, XSU_YMM,
+	    bad_xregs_info_flags },
+	{ "prxregset_info_t has bad type", EINVAL, XSU_YMM,
+	    bad_xregs_info_type },
+	{ "prxregset_info_t has bad len (XCR)", EINVAL, XSU_YMM,
+	    bad_xregs_info_xcr_len },
+	{ "prxregset_info_t has bad align (XCR)", EINVAL, XSU_YMM,
+	    bad_xregs_info_xcr_off },
+	{ "prxregset_info_t has bad len (XSAVE)", EINVAL, XSU_YMM,
+	    bad_xregs_info_xsave_len },
+	{ "prxregset_info_t has bad align (XSAVE)", EINVAL, XSU_YMM,
+	    bad_xregs_info_xsave_off },
+	{ "prxregset_info_t has bad len (YMM)", EINVAL, XSU_YMM,
+	    bad_xregs_info_ymm_len },
+	{ "prxregset_info_t has bad align (YMM)", EINVAL, XSU_YMM,
+	    bad_xregs_info_ymm_off },
+	{ "prxregset_info_t has bad len (OPMASK)", EINVAL, XSU_ZMM,
+	    bad_xregs_info_opmask_len },
+	{ "prxregset_info_t has bad align (OPMASK)", EINVAL, XSU_ZMM,
+	    bad_xregs_info_opmask_off },
+	{ "prxregset_info_t has bad len (ZMM)", EINVAL, XSU_ZMM,
+	    bad_xregs_info_zmm_len },
+	{ "prxregset_info_t has bad align (ZMM)", EINVAL, XSU_ZMM,
+	    bad_xregs_info_zmm_off },
+	{ "prxregset_info_t has bad len (HI ZMM)", EINVAL, XSU_ZMM,
+	    bad_xregs_info_hi_zmm_len },
+	{ "prxregset_info_t has bad align (HI ZMM)", EINVAL, XSU_ZMM,
+	    bad_xregs_info_hi_zmm_off },
+	{ "prxregset_info_t offset exceeds total len (offset beyond len)",
+	    EINVAL, XSU_YMM, bad_xregs_info_exceeds_len0 },
+	{ "prxregset_info_t offset exceeds total len (size+offset beyond len)",
+	    EINVAL, XSU_YMM, bad_xregs_info_exceeds_len1 },
+	{ "prxregset_info_t offset overlaps info", EINVAL, XSU_YMM,
+	    bad_xregs_info_overlaps },
+	{ "prxregset_t missing xsave struct", EINVAL, XSU_YMM,
+	    bad_xregs_no_xsave },
+	{ "prxregset_t missing xstate bit-vector entry", EINVAL, XSU_YMM,
+	    bad_xregs_missing_xstate },
+	{ "prxregset_xcr_t modified xcr0", EINVAL, XSU_YMM,
+	    bad_xregs_xcr_bad_xcr0 },
+	{ "prxregset_xcr_t modified xfd", EINVAL, XSU_YMM,
+	    bad_xregs_xcr_bad_xfd },
+	{ "prxregset_xcr_t modified pad[0]", EINVAL, XSU_YMM,
+	    bad_xregs_xcr_bad_pad0 },
+	{ "prxregset_xcr_t modified pad[1]", EINVAL, XSU_YMM,
+	    bad_xregs_xcr_bad_pad1 },
+	{ "prxregset_xsave_t illegal xbv comp", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_xbv },
+	{ "prxregset_xsave_t illegal compressed comp", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_xcomp },
+	{ "prxregset_xsave_t illegal rsvd[0]", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_rsvd0 },
+	{ "prxregset_xsave_t illegal rsvd[1]", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_rsvd1 },
+	{ "prxregset_xsave_t illegal rsvd[2]", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_rsvd2 },
+	{ "prxregset_xsave_t illegal rsvd[3]", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_rsvd3 },
+	{ "prxregset_xsave_t illegal rsvd[4]", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_rsvd4 },
+	{ "prxregset_xsave_t illegal rsvd[5]", EINVAL, XSU_YMM,
+	    bad_xregs_xsave_bad_rsvd5 },
+/*
+ * These next sets of tests are specific to 32-bit binaries as they're not
+ * allowed to access a bunch of the additional registers that exist.
+ */
+#ifdef __i386
+	{ "prxregset_ymm_t has non-zero reserved i386 reg", EINVAL, XSU_YMM,
+	    bad_xregs_ymm_ilp32 },
+	{ "prxregset_zmm_t has non-zero reserved i386 reg", EINVAL, XSU_ZMM,
+	    bad_xregs_zmm_ilp32 },
+	{ "prxregset_hi_zmm_t has non-zero reserved i386 reg", EINVAL, XSU_ZMM,
+	    bad_xregs_hi_zmm_ilp32 },
+#endif
+};
+
+int
+main(void)
+{
+	int ret;
+	int estatus = EXIT_SUCCESS;
+	struct ps_prochandle *P;
+	struct ps_lwphandle *L;
+	thread_t targ;
+	uint32_t hwsup;
+	uint32_t nskip = 0;
+
+	hwsup = xsu_hwsupport();
+	P = Pgrab(getpid(), PGRAB_RDONLY, &ret);
+	if (P == NULL) {
+		errx(EXIT_FAILURE, "failed to grab ourself: %s",
+		    Pgrab_error(ret));
+	}
+
+	ret = thr_create(NULL, 0, xsu_sleeper_thread, NULL, THR_DETACHED,
+	    &targ);
+	if (ret != 0) {
+		errc(EXIT_FAILURE, ret, "failed to create sleeper thread");
+	}
+
+	L = Lgrab(P, targ, &ret);
+	if (L == NULL) {
+		errx(EXIT_FAILURE, "failed to grab our sleeper thread: %s",
+		    Lgrab_error(ret));
+	}
+
+	ret = Lstop(L, 0);
+	if (ret != 0) {
+		err(EXIT_FAILURE, "failed to stop the sleeper thread");
+	}
+
+	if (Lgetxregs(L, &bad_xregs_pxr, &bad_xregs_size) != 0) {
+		err(EXIT_FAILURE, "failed to get basic xregs");
+	}
+
+	if (bad_xregs_size < sizeof (prxregset_hdr_t)) {
+		errx(EXIT_FAILURE, "found bad regset size: %zu",
+		    bad_xregs_size);
+	}
+
+	for (size_t i = 0; i < ARRAY_SIZE(bad_tests); i++) {
+		void *buf = NULL;
+		size_t len = 0;
+
+		if (bad_tests[i].bxt_min > hwsup) {
+			warnx("TEST SKIPPED: %s: requires greater hwsup than "
+			    "supported (0x%x)", bad_tests[i].bxt_desc,
+			    bad_tests[i].bxt_min);
+			nskip++;
+			continue;
+		}
+
+		bad_tests[i].bxt_setup(&buf, &len);
+		if (Lsetxregs(L, buf, len) != -1) {
+			warnx("TEST FAILED: %s: Lsetxregs returned 0, not -1!",
+			    bad_tests[i].bxt_desc);
+			estatus = EXIT_FAILURE;
+		} else if (errno != bad_tests[i].bxt_errno) {
+			warnx("TEST FAILED: %s: Lsetxregs errno was %d, "
+			    "expected %d", bad_tests[i].bxt_desc, errno,
+			    bad_tests[i].bxt_errno);
+			estatus = EXIT_FAILURE;
+		} else {
+			(void) printf("TEST PASSED: %s\n",
+			    bad_tests[i].bxt_desc);
+		}
+		free(buf);
+	}
+
+	if (estatus == EXIT_SUCCESS && nskip > 0) {
+		warnx("While tests were successful, %u tests were skipped "
+		    "due to missing hardware support", nskip);
+	}
+
+	exit(estatus);
+}
--- /dev/null	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/xsave/data/mdb_xregs.ymm.32	Wed Apr 12 20:33:28 2023
@@ -0,0 +1,52 @@
+x86 FPU with 256-bit %ymm registers
+xcr0            0x7
+xfd             0x0
+xstate_bv       0x7
+xcomp_bv        0x0
+
+%ymm0  [255:128] 0x12900929 12900928 12900927 12900926
+%xmm0  [127:0]   0x12900925 12900924 12900923 12900922
+
+%ymm1  [255:128] 0x12900931 12900930 1290092f 1290092e
+%xmm1  [127:0]   0x1290092d 1290092c 1290092b 1290092a
+
+%ymm2  [255:128] 0x12900939 12900938 12900937 12900936
+%xmm2  [127:0]   0x12900935 12900934 12900933 12900932
+
+%ymm3  [255:128] 0x12900941 12900940 1290093f 1290093e
+%xmm3  [127:0]   0x1290093d 1290093c 1290093b 1290093a
+
+%ymm4  [255:128] 0x12900949 12900948 12900947 12900946
+%xmm4  [127:0]   0x12900945 12900944 12900943 12900942
+
+%ymm5  [255:128] 0x12900951 12900950 1290094f 1290094e
+%xmm5  [127:0]   0x1290094d 1290094c 1290094b 1290094a
+
+%ymm6  [255:128] 0x12900959 12900958 12900957 12900956
+%xmm6  [127:0]   0x12900955 12900954 12900953 12900952
+
+%ymm7  [255:128] 0x12900961 12900960 1290095f 1290095e
+%xmm7  [127:0]   0x1290095d 1290095c 1290095b 1290095a
+
+387 and FP Control State
+cw     0x137f (IM|DM|ZM|OM|UM|PM|SIG64|RTN|A)
+sw     0x0000 (TOP=0t0) (0)
+xcp sw 0x0000 (0)
+
+ipoff  0
+cssel  0x43
+dtoff  0
+dtsel  0x4b
+
+%st0   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st1   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st2   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st3   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st4   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st5   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st6   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st7   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+
+SSE Control State
+mxcsr  0x1f80 (IM|DM|ZM|OM|UM|PM|RTN)
+xcp    0x0000 (RTN)
--- /dev/null	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/xsave/data/mdb_xregs.ymm.64	Wed Apr 12 20:33:28 2023
@@ -0,0 +1,75 @@
+x86 FPU with 256-bit %ymm registers
+xcr0            0x7
+xfd             0x0
+xstate_bv       0x7
+xcomp_bv        0x0
+
+%ymm0  [255:128] 0x1190045d 1190045c 1190045b 1190045a
+%xmm0  [127:0]   0x11900459 11900458 11900457 11900456
+
+%ymm1  [255:128] 0x11900465 11900464 11900463 11900462
+%xmm1  [127:0]   0x11900461 11900460 1190045f 1190045e
+
+%ymm2  [255:128] 0x1190046d 1190046c 1190046b 1190046a
+%xmm2  [127:0]   0x11900469 11900468 11900467 11900466
+
+%ymm3  [255:128] 0x11900475 11900474 11900473 11900472
+%xmm3  [127:0]   0x11900471 11900470 1190046f 1190046e
+
+%ymm4  [255:128] 0x1190047d 1190047c 1190047b 1190047a
+%xmm4  [127:0]   0x11900479 11900478 11900477 11900476
+
+%ymm5  [255:128] 0x11900485 11900484 11900483 11900482
+%xmm5  [127:0]   0x11900481 11900480 1190047f 1190047e
+
+%ymm6  [255:128] 0x1190048d 1190048c 1190048b 1190048a
+%xmm6  [127:0]   0x11900489 11900488 11900487 11900486
+
+%ymm7  [255:128] 0x11900495 11900494 11900493 11900492
+%xmm7  [127:0]   0x11900491 11900490 1190048f 1190048e
+
+%ymm8  [255:128] 0x1190049d 1190049c 1190049b 1190049a
+%xmm8  [127:0]   0x11900499 11900498 11900497 11900496
+
+%ymm9  [255:128] 0x119004a5 119004a4 119004a3 119004a2
+%xmm9  [127:0]   0x119004a1 119004a0 1190049f 1190049e
+
+%ymm10 [255:128] 0x119004ad 119004ac 119004ab 119004aa
+%xmm10 [127:0]   0x119004a9 119004a8 119004a7 119004a6
+
+%ymm11 [255:128] 0x119004b5 119004b4 119004b3 119004b2
+%xmm11 [127:0]   0x119004b1 119004b0 119004af 119004ae
+
+%ymm12 [255:128] 0x119004bd 119004bc 119004bb 119004ba
+%xmm12 [127:0]   0x119004b9 119004b8 119004b7 119004b6
+
+%ymm13 [255:128] 0x119004c5 119004c4 119004c3 119004c2
+%xmm13 [127:0]   0x119004c1 119004c0 119004bf 119004be
+
+%ymm14 [255:128] 0x119004cd 119004cc 119004cb 119004ca
+%xmm14 [127:0]   0x119004c9 119004c8 119004c7 119004c6
+
+%ymm15 [255:128] 0x119004d5 119004d4 119004d3 119004d2
+%xmm15 [127:0]   0x119004d1 119004d0 119004cf 119004ce
+
+387 and FP Control State
+cw     0x137f (IM|DM|ZM|OM|UM|PM|SIG64|RTN|A)
+sw     0x0000 (TOP=0t0) (0)
+xcp sw 0x0000 (0)
+
+fop    0x0
+rip    0x0
+rdp    0x0
+
+%st0   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st1   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st2   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st3   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st4   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st5   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st6   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st7   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+
+SSE Control State
+mxcsr  0x1f80 (IM|DM|ZM|OM|UM|PM|RTN)
+xcp    0x0000 (RTN)
--- /dev/null	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/xsave/data/mdb_xregs.zmm.32	Wed Apr 12 20:33:28 2023
@@ -0,0 +1,73 @@
+x86 FPU with 512-bit %zmm registers
+xcr0            0xe7
+xfd             0x0
+xstate_bv       0x67
+xcomp_bv        0x0
+
+%zmm0  [511:384] 0x12900931 12900930 1290092f 1290092e
+       [383:256] 0x1290092d 1290092c 1290092b 1290092a
+%ymm0  [255:128] 0x12900929 12900928 12900927 12900926
+%xmm0  [127:0]   0x12900925 12900924 12900923 12900922
+
+%zmm1  [511:384] 0x12900941 12900940 1290093f 1290093e
+       [383:256] 0x1290093d 1290093c 1290093b 1290093a
+%ymm1  [255:128] 0x12900939 12900938 12900937 12900936
+%xmm1  [127:0]   0x12900935 12900934 12900933 12900932
+
+%zmm2  [511:384] 0x12900951 12900950 1290094f 1290094e
+       [383:256] 0x1290094d 1290094c 1290094b 1290094a
+%ymm2  [255:128] 0x12900949 12900948 12900947 12900946
+%xmm2  [127:0]   0x12900945 12900944 12900943 12900942
+
+%zmm3  [511:384] 0x12900961 12900960 1290095f 1290095e
+       [383:256] 0x1290095d 1290095c 1290095b 1290095a
+%ymm3  [255:128] 0x12900959 12900958 12900957 12900956
+%xmm3  [127:0]   0x12900955 12900954 12900953 12900952
+
+%zmm4  [511:384] 0x12900971 12900970 1290096f 1290096e
+       [383:256] 0x1290096d 1290096c 1290096b 1290096a
+%ymm4  [255:128] 0x12900969 12900968 12900967 12900966
+%xmm4  [127:0]   0x12900965 12900964 12900963 12900962
+
+%zmm5  [511:384] 0x12900981 12900980 1290097f 1290097e
+       [383:256] 0x1290097d 1290097c 1290097b 1290097a
+%ymm5  [255:128] 0x12900979 12900978 12900977 12900976
+%xmm5  [127:0]   0x12900975 12900974 12900973 12900972
+
+%zmm6  [511:384] 0x12900991 12900990 1290098f 1290098e
+       [383:256] 0x1290098d 1290098c 1290098b 1290098a
+%ymm6  [255:128] 0x12900989 12900988 12900987 12900986
+%xmm6  [127:0]   0x12900985 12900984 12900983 12900982
+
+%zmm7  [511:384] 0x129009a1 129009a0 1290099f 1290099e
+       [383:256] 0x1290099d 1290099c 1290099b 1290099a
+%ymm7  [255:128] 0x12900999 12900998 12900997 12900996
+%xmm7  [127:0]   0x12900995 12900994 12900993 12900992
+
+%k0  0x00000000129009a2         %k1  0x00000000129009a3
+%k2  0x00000000129009a6         %k3  0x00000000129009a7
+%k4  0x00000000129009aa         %k5  0x00000000129009ab
+%k6  0x00000000129009ae         %k7  0x00000000129009af
+
+387 and FP Control State
+cw     0x137f (IM|DM|ZM|OM|UM|PM|SIG64|RTN|A)
+sw     0x0000 (TOP=0t0) (0)
+xcp sw 0x0000 (0)
+
+ipoff  0
+cssel  0x43
+dtoff  0
+dtsel  0x4b
+
+%st0   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st1   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st2   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st3   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st4   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st5   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st6   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+%st7   0x0000.0000000000000000 = +0.0000000000000000e+00 empty
+
+SSE Control State
+mxcsr  0x1f80 (IM|DM|ZM|OM|UM|PM|RTN)
+xcp    0x0000 (RTN)
